#include "list_1 (1).h"
#include "list.h"
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

// Gimme the number of elements of L
int get_numelm(struct list_t * L){
    assert(L);
    return L->numelm;
}
// Take out the data D of the list L if it is present
void take_out(struct list_t * L, void * D){
  assert(L);
  elmlist_t * current = L->head;
  while (current != NULL) {
      if (get_data(current) == D) {
          elmlist_t * p = get_pred(current);
          elmlist_t * s = get_suc(current);
          // Update predecessor’s successor
          if (p) set_suc(p, s);
          else L->head = s;  // current was head
          // Update successor’s predecessor
          if (s) set_pred(s, p);
          else L->tail = p;  // current was tail
          free(current);
          L->numelm--;
          return;
      }
      current = get_suc(current);
  }
}

// Add a element holding data to the head of L
void cons(struct list_t * L, void * data){
    elmlist_t * E = calloc(1, sizeof(elmlist_t));
    assert(L && E);
    set_data(E, data);
    set_suc(E, L->head);
    set_head(L, E);
    if(is_empty(L)) L->tail = E;
    L->numelm += 1;
 }




// Add  a element holding data to the tail of L
void queue(struct list_t * L, void * data){
  assert(L);
  elmlist_t * E = calloc(1, sizeof(elmlist_t));
  assert(E);
  set_data(E, data);
  E->suc = NULL;
  if (is_empty(L)) {
      E->pred = NULL;
      L->head = E;
      L->tail = E;
  } else {
      E->pred = L->tail;
      L->tail->suc = E;
      L->tail = E;
  }
  L->numelm++;
  }
// Insert in L a element holding data wrt order given by cmp_ptrf
void ordered_insert(struct list_t * L, void * data, int (*cmp_ptrf)()){
  assert(L && cmp_ptrf);
  elmlist_t * E = calloc(1, sizeof(elmlist_t));
  assert(E);
  set_data(E, data);
  // if list is empty, simply add the element
  if (is_empty(L)) {
      E->pred = E->suc = NULL;
      L->head = L->tail = E;
      L->numelm++;
      return;
  }
}

// Elements with data less than pivot go into val_inf; the rest go into val_sup.
static void partition(list_t * L, elmlist_t * pivot, list_t * val_inf, list_t * val_sup, int (*cmpFct)(void*, void*)) {
    for (elmlist_t * cur = L->head; cur != NULL; cur = cur->suc) {
        if (cmpFct(get_data(cur), get_data(pivot)) < 0)
            queue(val_inf, get_data(cur));
        else
            queue(val_sup, get_data(cur));
    }
}

void quick_sort(list_t * L, int (*cmpFct)(void*, void*)) {
    assert(L && cmpFct);

    if (L->numelm > 1) {
        // Remove pivot from L.
        elmlist_t * pivot = get_head(L);
        L->head = get_suc(pivot); // Remainder of L.
        pivot->pred = NULL;
        pivot->suc = NULL;

        list_t * val_inf_pivot = new_list();
        list_t * val_sup_pivot = new_list();

        // Partition sur les restes de la liste
        partition(L, pivot, val_inf_pivot, val_sup_pivot, cmpFct);

        // Free the original list's elements (they have been reinserted in the new lists)
        elmlist_t * S;
        for (elmlist_t * E = L->head; E; E = S) {
            S = E->suc;
            free(E);
        }

        // Process elements less than pivot.
        if (is_empty(val_inf_pivot)) {
            L->head = pivot;
            L->tail = pivot;
            L->numelm = 1;
        } else {
            quick_sort(val_inf_pivot, cmpFct);
            L->head = val_inf_pivot->head;
            L->tail = val_inf_pivot->tail;
            L->numelm = val_inf_pivot->numelm;
            pivot->pred = L->tail;
            L->tail->suc = pivot;
            L->tail = pivot;
            L->numelm += 1;
        }
        // Process elements greater than or equal to the pivot.
        if (!is_empty(val_sup_pivot)) {
            quick_sort(val_sup_pivot, cmpFct);
            val_sup_pivot->head->pred = pivot;
            pivot->suc = val_sup_pivot->head;
            L->tail = val_sup_pivot->tail;
            L->numelm += val_sup_pivot->numelm;
        }
        free(val_inf_pivot);
        free(val_sup_pivot);
    }
}

// void quick_sort(list_t * L, int (*cmpFct)()){

//     if (L == NULL || L->numelm < 2)
//         return;


//     elmlist_t * pivotNode = L->head;
//     void * pivotData = pivotNode->data;


//     list_t * less = new_list();
//     list_t * greater = new_list();


//     for (elmlist_t * cur = L->head; cur != NULL; cur = cur->suc) {

//         if (cur == pivotNode)
//             continue;

//         if (cmpFct(cur->data, pivotData) < 0)
//             queue(less, cur->data);
//         else
//             queue(greater, cur->data);
//     }


//     clean(L);


//     quick_sort(less, cmpFct);
//     quick_sort(greater, cmpFct);

//     for (elmlist_t * node = less->head; node != NULL; node = node->suc)
//         queue(L, node->data);


//     queue(L, pivotData);

//     for (elmlist_t * node = greater->head; node != NULL; node = node->suc)
//         queue(L, node->data);

//     free(less);
//     free(greater);
// }




// View list
void view_list(list_t * L, void (*ptrf)()) {
  assert(L && ptrf);
  elmlist_t * curr = L->head;
  while (curr) {
      ptrf(get_data(curr));
      curr = curr->suc;
  }

}
// Return a ptr to element which data is key else NULL
void find(list_t * L, void ** ptrKey, int (*cmpFct)(), void (*delFct)()) {
  assert(L && ptrKey && cmpFct);
  elmlist_t * curr = L->head;
  while (curr) {
      if (cmpFct(get_data(curr), *ptrKey) == 0) {
          if (delFct)
              delFct(ptrKey);
          *ptrKey = get_data(curr);
          return;
      }
      curr = curr->suc;
  }
}
